
#include "LCD_2x16_74HC595_8bit.h"

#define SHIFT_CLOCK  RB1_bit
#define SHIFT_DATA   RB0_bit
#define SHIFT_LATCH  RB2_bit

char LCD_port=0;

void shiftdata595(unsigned char _shiftdata)
{
unsigned int i;
unsigned char temp;
temp = _shiftdata;
i=8;
while (i>0)
{
if ((temp&0x80)==0)
{
SHIFT_DATA = 0;
}
else
{
SHIFT_DATA = 1;
}
temp = temp<<1;
SHIFT_CLOCK = 1;
Delay_us(1);
SHIFT_CLOCK = 0;
i--;
}
}

void Latch(){

SHIFT_LATCH = 1;
Delay_us(2);
SHIFT_LATCH = 0;
Delay_us(2);

}
void LCD_Command(char data1)        /* LCD16x2 command funtion */
{
 shiftdata595(data1);
 shiftdata595(0x10);
 Latch();
 delay_us(400);
 shiftdata595(data1);
 shiftdata595(0x00);
 Latch();
 delay_ms(2);
}
void Lcd_Chr_CP(char data1){

 shiftdata595(data1);
 shiftdata595(0x14);
 Latch();
 delay_us(400);
 shiftdata595(data1);
 shiftdata595(0x04);
 Latch();
 delay_ms(2);

}
void LCD_Char_xy (char row, char pos, char ch)  /* Send string to LCD function */
{
char i=0;

    switch(row){
    case 1:
      LCD_Command(0x80 + pos-1);
      break;
    case 2:
      LCD_Command(0xC0 + pos-1);
      break;
    case 3:
      LCD_Command(0x94 + pos-1);
      break;
    case 4:
      LCD_Command(0xD4 + pos-1);
    break;
 }
     Lcd_Chr_CP (ch);

}
void LCD_String_xy (char row, char pos, char *str)  /* Send string to LCD function */
{
char i=0;

    switch(row){
    case 1:
      LCD_Command(0x80 + pos-1);
      break;
    case 2:
      LCD_Command(0xC0 + pos-1);
      break;
    case 3:
      LCD_Command(0x94 + pos-1);
      break;
    case 4:
      LCD_Command(0xD4 + pos-1);
    break;
  }

        
 for(i=0;str[i]!=0;i++)  /* Send each char of string till the NULL */
        {
         Lcd_Chr_CP (str[i]);  /* Call LCD data write */
        }
}

 void LCD_Init (void)                /* LCD Initialize function */
{
        delay_ms(15);                /* LCD Power ON Initialization time >15ms */
        LCD_Command (0x38);        /* Initialization of 16X2 LCD in 8bit mode */
        LCD_Command (0x0C);        /* Display ON Cursor OFF */
        LCD_Command (0x06);        /* Auto Increment cursor */
        LCD_Command (0x01);        /* clear display */
        LCD_Command (0x80);        /* cursor at home position */

}